# lab1_2.py -- template for your Task #2 design file
import numpy as np
import matplotlib
matplotlib.use('WXAgg')
import matplotlib.pyplot as p
import lab1

#matplotlib.interactive(True)

def plot_data(data):

	xaxis = np.arange(data.shape[0])
	p.plot(xaxis, data, 'r-') # Change to 'g^' to see points on graph
	p.ylabel('Voltage')
	p.xlabel('Sample Number')
	p.grid(True)
	p.title('Receiver Data')
	p.show()

def v_samples_to_d_samples(samples):
    
	bits = (samples>0) * 1
	
	#plot_data(bits)  #Use to verify samples convert to 1's and 0's

	return(bits)

def find_center_of_start_bit(d_samples,start,samples_per_bit):
    
	mid = samples_per_bit/2 
	i = start
	while i < d_samples.shape[0]-mid and d_samples[i].item() == 0:
		i+=1
		
	if i >= d_samples.shape[0]-mid:
		return -1
	else:
		return i+mid
		

def decode_data(d_samples,start,nbits,samples_per_bit):
  
	i = start
	bits = []
	while i < start+samples_per_bit*nbits:
		bits.append(d_samples[i].item())
		i += samples_per_bit
	
	print bits
	
	return bits

def receive(samples):
    """
    Convert an array of voltage samples into a message string.
    """
    # digitize the voltage samples
    d_samples = v_samples_to_d_samples(samples)
    nsamples = len(d_samples)

    # search through the samples starting at the beginning
    message = []
    start = 0
    while True:
        # locate sample at middle of next START bit
        start = find_center_of_start_bit(d_samples,start,8)
        if start < 0 or start + 10*8 >= nsamples:
            break  # no START bit found or too near end of samples

        # grab the eight data bits which follow
        bits = decode_data(d_samples,start+8,8,8)

        # first convert bit sequence to an int
        # and then to a character, append to message
        message.append(chr(lab1.bits_to_int(bits)))

        # finally skip to the middle of the STOP bit
        # and start looking for the next START bit
        start += 9*8

    # join all the message characters into a single string
    return "".join(message)

# testing code.  Do it this way so we can import this file
# and use its functions without also running the test code.
if __name__ == '__main__':
    # see if we can decode the message
    lab1.task2_test(receive,'hi there')
