

# lab1_3.py -- template for your Task #3 design file
import numpy as np
import matplotlib
matplotlib.use('WXAgg')
import matplotlib.pyplot as p
import lab1

def plot_data(data):

	xaxis = np.arange(data.shape[0])
	p.plot(xaxis, data, 'r-') # Change to 'g^' to see points on graph
	p.ylabel('Voltage')
	p.xlabel('Sample Number')
	p.grid(True)
	p.title('Receiver Data')
	p.show()
	
def v_samples_to_d_samples(samples):
	
	bits = (samples>0) * 1
	
	#plot_data(bits)
	
	return(bits)

def d_samples_to_bits(samples, samples_per_bit):
	
	lastSample = 0
	i = 0
	count = i
	length = samples.shape[0]
	bits = []
	
	while i < length:
		currentSample = samples[i].item()
		
		#If there's a transition, resync
		if currentSample != lastSample:
			count = 0
			
		#If you're in the middle of a bit region, sample it	
		if count == samples_per_bit/2:
			bits.append(currentSample)
		
		i += 1
		lastSample = currentSample
		count = (count+1) % samples_per_bit
		
	#print bits	
		
	return bits
	
def bits_to_ints(bits):
	
	sync = (np.array([0,0,1,1,1,1,1,0,1,0]), np.array([1,1,0,0,0,0,0,1,0,1]))
	ints = []
	i = 0 #index
	start = False
	
	while i < len(bits):
		currentInt = np.array(bits[i:i+10]) #sliding window of next 10 bits
		if start:
			value = lab1.bits_to_int(currentInt)
			ints.append(value)
			i += 10
		elif np.array_equal(sync[0], currentInt) or np.array_equal(sync[1], currentInt):
			i += 10
			start = True
		else:
			i += 1
		
	return ints
		
		
def ints_to_message(ints):
	
	message = ''
	for i in ints:
		char = lab1.table_10b_8b[i]
		if char != None:
			message+=chr(char)

	return message

def receive_8b10b(samples):
    
	d_samples = v_samples_to_d_samples(samples)
	
	bits = d_samples_to_bits(d_samples, 8)
	
	ints = bits_to_ints(bits)
	
	message = ints_to_message(ints)
	
	return message

# testing code.  Do it this way so we can import this file
# and use its functions without also running the test code.
if __name__ == '__main__':
    # supply some test data....
    lab1.task3_test(receive_8b10b,lab1.long_message)
