# template for Lab #2, Task #2
import matplotlib
matplotlib.use('WXAgg')
import matplotlib.pyplot as p
import lab2
import numpy as np

# turn on interactive mode, useful if we're using ipython
#p.ion()  

def transmit(bits,npreamble=0,
			 npostamble=0,
			 samples_per_bit=8,
			 v0 = 0.0,
			 v1 = 1.0,
			 repeat = 1):

	samples = np.array([])

	for ntimes in range(repeat):
		
		for prefix in range(npreamble):
			samples = np.append(samples, [v0])
	
		for bit in bits:
			for s in range(samples_per_bit):
				if bit == 1:
					samples = np.append(samples, [v1])
				else:
					samples = np.append(samples, [v0])
				
		for postfix in range(npostamble):
			samples = np.append(samples, [v0])	
			
	return samples

def test_channel(channel):
    
	bits = [1,0,1,0,1,0,1,0]
	inp = transmit(bits, 10, 100)
	out = channel(inp)
	
	xaxis = np.arange(inp.shape[0])
	
	p.figure()
	p.subplot(211)
	p.plot(xaxis, inp, 'r-')
	p.axis([0, inp.shape[0], -0.1, 1.1])
	p.ylabel('Voltage')
	p.grid(True)
	p.title('Input')
	
	p.subplot(212)
	p.plot(xaxis, out, 'b-')
	p.axis([0, inp.shape[0], -0.1, 1.1])
	p.ylabel('Voltage')
	p.xlabel('Sample Number')
	p.grid(True)
	p.title('Output')
	

if __name__ == '__main__':
    # try out our two channels
    test_channel(lab2.channel1)
    test_channel(lab2.channel2)

    # interact with plots before exiting.  p.show() returns
    # after all plot windows have been closed by the user.
    # Not needed if using ipython
    p.show()  

