import matplotlib
matplotlib.use('WXAgg')

#Lab #2, Task #4
import numpy as np
import matplotlib.pyplot as p
import lab2

# turn on interactive mode, useful if we're using ipython
#p.ion()

def transmit(bits,npreamble=0,
			 npostamble=0,
			 samples_per_bit=8,
			 v0 = 0.0,
			 v1 = 1.0,
			 repeat = 1):

	samples = np.array([])

	for ntimes in range(repeat):
		
		for prefix in range(npreamble):
			samples = np.append(samples, [v0])
	
		for bit in bits:
			for s in range(samples_per_bit):
				if bit == 1:
					samples = np.append(samples, [v1])
				else:
					samples = np.append(samples, [v0])
				
		for postfix in range(npostamble):
			samples = np.append(samples, [v0])	
			
	return samples

def unit_sample_response(channel):
	
	samples = [1.0]+[0.0]*1000
	response = channel(samples)
	
	maxS = 0.0
	count = 0
	for s in range(1000):
		if response[s] > maxS:
			maxS = response[s]
		if response[s]*100 < maxS:
			count += 1
		else:
			count = 0
		if count >= 10:
			break
	
	return response[:s]
	
def test_channel(channel):

	bits = [1,0,1,0,1,0,1,0]
	inp = transmit(bits, 10, 100)
	out = channel(inp)

	xaxis = np.arange(inp.shape[0])

	p.figure()
	p.subplot(311)
	p.plot(xaxis, inp, 'r-')
	p.axis([0, inp.shape[0], -0.1, 1.1])
	p.ylabel('Voltage')
	p.grid(True)
	p.title('Input')

	p.subplot(312)
	p.plot(xaxis, out, 'b-')
	p.axis([0, inp.shape[0], -0.1, 1.1])
	p.ylabel('Voltage')
	p.grid(True)
	p.title('Output')	
	

def channel_display(channel):
	x = transmit([1,0,1,0,1,0,1,0], 10, 100)
	h = unit_sample_response(channel)
	w = np.convolve(x, h)
	test_channel(channel)

	xaxis = np.arange(w.shape[0])	
	p.subplot(313)
	p.plot(xaxis, w, 'g-')
	p.axis([0, x.shape[0], -0.1, 1.1])
	p.ylabel('Voltage')
	p.xlabel('Sample Number')
	p.grid(True)
	p.title('Anticipated Response')	

if __name__ == '__main__':
	
	channel_display(lab2.channel1)
	channel_display(lab2.channel2)
	
	
	p.show()  
