# template for Lab #2, Task #5
import random
import numpy as np
import matplotlib
matplotlib.use('WXAgg')
import matplotlib.pyplot as p
import lab2

# turn on interactive mode, useful if we're using ipython
#p.ion()  

def transmit(bits,npreamble=0,
			 npostamble=0,
			 samples_per_bit=8,
			 v0 = 0.0,
			 v1 = 1.0,
			 repeat = 1):

	samples = np.array([])

	for ntimes in range(repeat):
		
		for prefix in range(npreamble):
			samples = np.append(samples, [v0])
	
		for bit in bits:
			for s in range(samples_per_bit):
				if bit == 1:
					samples = np.append(samples, [v1])
				else:
					samples = np.append(samples, [v0])
				
		for postfix in range(npostamble):
			samples = np.append(samples, [v0])	
			
	return samples

def plot_eye_diagram(channel,samples_per_bit=8):
    
	plot_samples = samples_per_bit*2

	bits = []
	for b in range(200):
		bits.append(random.randint(0,1))
		
	x = transmit(bits,0,0,samples_per_bit)
	y = channel(x)
	
	p.figure()
	
	xaxis = np.arange(plot_samples)
	for window in range(199*samples_per_bit/plot_samples):
		p.plot(xaxis, y[window*plot_samples:(window+1)*plot_samples], 'r-')
		
	p.axis([0, plot_samples, -0.1, 1.1])
	p.ylabel('Voltage')
	p.xlabel('Samples')
	p.grid(True)
	p.title('Eye Diagram')

if __name__ == '__main__':
    # plot the eye diagram for both our channels

    # Experiment with different values of samples_per_bit for both
    # channels until you feel that the eye is open enough to permit
    # successful reception of the transmitted bits.  The result
    # will be different for the two channels.
    plot_eye_diagram(lab2.channel1,samples_per_bit=25)
    plot_eye_diagram(lab2.channel2,samples_per_bit=15)

	#SCOTT'S NOTE: These values correspond to an eye with a minimum width of .2, which may or may not be acceptable

    # interact with plots before exiting.  p.show() returns
    # after all plot windows have been closed by the user.
    # Not needed if using ipython
    p.show()  
