# this is the template for Lab #3, Task #4
import matplotlib.pyplot as p
import math,numpy,random
import lab3

def max_avg(samples,samples_per_bit=4,vth=0.5):
	bins = numpy.reshape(samples,(-1,samples_per_bit))
	maxAvg = 0
	maxLoc = 0
	c = 0
	for i in xrange(samples_per_bit):
		column = bins[:,i]
		dist = column - vth
		avg = numpy.average(abs(dist))
		if avg >= maxAvg:
			maxAvg = avg
			maxLoc = c
		c+=1
		
	return maxLoc

def receive(samples,samples_per_bit=4,vth=0.5):

	lookup = max_avg(samples, samples_per_bit, vth)
	print lookup
	d_samples = 1*(samples>vth)
	
	bits = [d_samples[samples_per_bit*n + lookup] for n in range(len(samples)/samples_per_bit)]
	
	return bits

def bit_error_rate(seq1,seq2):
	numErrors = 0
	for n in range(len(seq1)):
		if seq1[n] != seq2[n]:
			numErrors +=1
			
	return(numErrors/float(len(seq2)))

if __name__ == '__main__':
	message = [random.randint(0,1) for i in xrange(100000)]
	noisy_data = lab3.transmit(message,samples_per_bit=4,nmag=1.0)
	received_message = receive(noisy_data)
	ber = bit_error_rate(message,received_message)
	print "bit error rate = %g" % ber
