import matplotlib
matplotlib.use('WXAgg')

# template file for Lab #6, Task #1
import numpy
import matplotlib.pyplot as p
import lab6

def unit_sample_response(channel):
	
	samples = [1.0]+[0.0]*1000
	response = channel(samples)
	
	maxS = 0.0
	count = 0
	for s in range(1000):
		if response[s] > maxS:
			maxS = response[s]
		if response[s]*100 < maxS:
			count += 1
		else:
			count = 0
		if count >= 10:
			break
	
	return response[:s]

def freq_res_usr(usr, num_freqs=401):
	# 0 <= omega <= pi
	omega_list = numpy.linspace(0,numpy.pi,num=num_freqs)

	hejw = []
	for w in omega_list:
		ejw = numpy.exp([-m*w*1j for m in xrange(len(usr))])
		hejw.append(numpy.sum(usr*ejw))
		
	return omega_list,numpy.abs(hejw)
	
def freq_res(channel, num_freqs=401):
	usr = unit_sample_response(channel) # Get channel's u.s.r.
	return freq_res_usr(usr,num_freqs)

if __name__ == '__main__':
	# generate plots of freq_2_usr for both channels
	# using both of the methods
	omega_1, mag_hejw_chan1 = freq_res(lab6.channel1)
	lab6.plot_freq_response(omega_1, mag_hejw_chan1,'channel 1')

	omega_2, mag_hejw_chan2 = freq_res(lab6.channel2)
	lab6.plot_freq_response(omega_2, mag_hejw_chan2,'channel 2')

	p.show()
